Subject: Re: [PATCH net-next 01/10] net: stmmac: fix TSO support when some channels have TBS available

From: Jakub Kicinski <[email-masked]>
Date: Sun, 29 Mar 2026 10:42:23 -0700

On Sun, 29 Mar 2026 10:40:43 +0100 Russell King (Oracle) wrote:
> On Sat, Mar 28, 2026 at 09:36:41PM +0000, Russell King (Oracle) wrote:
> > According to the STM32MP25xx manual, which is dwmac v5.3, TBS (time
> > based scheduling) is not permitted for channels which have hardware
> > TSO enabled. Intel's commit 5e6038b88a57 ("net: stmmac: fix TSO and
> > TBS feature enabling during driver open") concurs with this, but it
> > is incomplete.
> > 
> > This commit avoids enabling TSO support on the channels which have
> > TBS available, which, as far as the hardware is concerned, means we
> > do not set the TSE bit in the DMA channel's transmit control register.
> > 
> > However, the net device's features apply to all queues(channels), which
> > means these channels may still be handed TSO skbs to transmit, and the
> > driver will pass them to stmmac_tso_xmit(). This will generate the
> > descriptors for TSO, even though the channel has the TSE bit clear.
> > 
> > Fix this by checking whether the queue(channel) has TBS available,
> > and if it does, fall back to software GSO support.  
> 
> This is sufficient for the immediate issue of fixing the patch below,
> but I think there's another issue that also needs fixing here.
> 
> TSO requires the hardware to support checksum offload, and there is
> a comment in the driver:
> 
>         /* DWMAC IPs can be synthesized to support tx coe only for a few tx
>          * queues. In that case, checksum offloading for those queues that don't
>          * support tx coe needs to fallback to software checksum calculation.
>          *
>          * Packets that won't trigger the COE e.g. most DSA-tagged packets will
>          * also have to be checksummed in software.
>          */
> 
> So, it seems at the very least we need to add a check (in a subsequent
> patch) for priv->plat->tx_queues_cfg[queue].coe_unsupported to
> stmmac_channel_tso_permitted().
> 
> I'm also wondering about the stmmac_has_ip_ethertype() thing, which
> checks whether the skb can be checksummed by the hardware, and how that
> interacts with TSO, and whether that's yet another hole that needs
> plugging.

If the driver "un-advertises" checksum offload accordingly the core
should automatically clear TSO feature.